//////////////////////////////////////////////////////////////////////
// Point.cpp: implementation of the Point class.
//////////////////////////////////////////////////////////////////////
#include "stdafx.h"
#include "Point.h"
#include <iostream>

int Point::count = 0;

Point::Point(const Point &other)
{
	m_nX = other.m_nX;
	m_nY = other.m_nY;
}

Point::Point(const int *other)
{
	m_nX = other[0];
	m_nY = other[1];
}

Point::Point(int nX, int nY)
{
	m_nX = nX;
	m_nY = nY;
}

void Point::SetPosition(int nX, int nY)
{
	m_nX = nX;
	m_nY = nY;
}

void Point::Move(int nX, int nY)
{
	m_nX += nX;
	m_nY += nY;
}

void Point::Show()
{
	std::cout << "X= " << m_nX << " Y= " << m_nY << std::endl;
}

Point& Point::operator++()
{
	SetPosition(++m_nX, ++m_nY);
	return *this;
}

Point Point::operator + ( const Point &other )
{
    Point vResult(0, 0);

    vResult.m_nX = m_nX + other.m_nX;
    vResult.m_nY = m_nY + other.m_nY;

    return vResult;
}

// This function is required for built-in STL list functions like sort
int Point::operator < (const Point &rhs) const
{
   if( this->m_nX == rhs.m_nX && this->m_nY < rhs.m_nY) return 1;
   if( this->m_nX < rhs.m_nX ) return 1;
   return 0;
}

// This function is required for built-in STL list functions like find
int Point::operator==(const Point &rhs) const
{
   if( this->m_nX == rhs.m_nX && this->m_nY == rhs.m_nY) return 1;
   return 0;
}
