// Point.h: interface for the Point class.
// 
//////////////////////////////////////////////////////////////////////
#ifndef __POINT_H__
#define __POINT_H__

class Point  
{
public:
	Point() { count++; };
    Point(const Point &other);
	Point(const int *other);
    Point(int nX, int nY);
	virtual ~Point() { count--; };

	// member function
	void SetPosition(int nX=10, int nY=10);
	void Move(int nX, int nY);
	virtual void Show();

	// operator
	Point& operator++();
	Point operator+(const Point &other);
	int operator<(const Point &other) const;
	int operator==(const Point &other) const;

	// member variable
	int m_nX, m_nY;

	// static variable
	static int count;
};

#endif