//////////////////////////////////////////////////////////////////////
// Point3D.cpp: implementation of the Point class.
//////////////////////////////////////////////////////////////////////

#include "stdafx.h"
#include "Point3D.h"
#include <iostream>

Point3D::Point3D(const Point3D &other)
{
	m_nX = other.m_nX;
	m_nY = other.m_nY;
	m_nZ = other.m_nZ;
}

Point3D::Point3D(const int *other)
{
	m_nX = other[0];
	m_nY = other[1];
	m_nZ = other[2];
}

Point3D::Point3D(int nX, int nY, int nZ)
{
	m_nX = nX;
	m_nY = nY;
	m_nZ = nZ;
}

void Point3D::SetPosition(int nX, int nY, int nZ)
{
	m_nX = nX;
	m_nY = nY;
	m_nZ = nZ;
}

void Point3D::Move(int nX, int nY, int nZ)
{
	m_nX += nX;
	m_nY += nY;
	m_nZ += nZ;
}

void Point3D::Show()
{
	std::cout << "X=" << m_nX << " Y=" << m_nY << " Z=" << m_nZ << std::endl;
}

Point3D& Point3D::operator++()
{
	SetPosition(++m_nX, ++m_nY, ++m_nZ);
	return *this;
}

Point3D Point3D::operator + (const Point3D &other)
{
    Point3D vResult(0, 0, 0);

    vResult.m_nX = m_nX + other.m_nX;
    vResult.m_nY = m_nY + other.m_nY;
    vResult.m_nZ = m_nY + other.m_nZ;

    return vResult;
}

// This function is required for built-in STL list functions like sort
int Point3D::operator < (const Point3D &rhs) const
{
   if( this->m_nX == rhs.m_nX && this->m_nY == rhs.m_nY && this->m_nZ < rhs.m_nZ) return 1;
   if( this->m_nX == rhs.m_nX && this->m_nY < rhs.m_nY) return 1;
   if( this->m_nX < rhs.m_nX ) return 1;
   return 0;
}

// This function is required for built-in STL list functions like find
int Point3D::operator == (const Point3D &rhs) const
{
   if( this->m_nX == rhs.m_nX && this->m_nY == rhs.m_nY && this->m_nZ == rhs.m_nZ) return 1;
   return 0;
}
